-*-Python-*-

World:
    have things, current time and list of ids
    add thing: add thing to things list and assign it id
    remove thing: remove it from things list and set its id to illegal_thing
    get_thing_list: return list of things
    event methods:
        make_event: add it to internal list and let others see its creation
        destroy_event: 
            remove it from internal list and let others see its destruction
        undefined_event: pass others unaffected
        analyse_event: set source to current thing if not already defined
    analyse_event, analyse_input: run things through event methods
    new_events: add new events
    every time step:
        for all things: make them older
        make list of targeted events keyed by target
        for all things: 
            run_step with all events that are not targeted or\
                     are targeted at it
            make list events that each thing emitted
        process output events from things:
            run events through analyse_input and \
                add them to list for next timestep

Thing: 
    have id, name, place, status and age
    location is xyz if defined, else its place
    type is things class derivation to root class
    event handling:
        move_event:
            if it is moving into something, use it as place
            else set xyz to target
            generate sight event about movement
        change_event:
            change status by amount:
                if reduced below 0: send destroy event
                else: send sight event about change
        undefined_event: ignore
        analyse_input: go through all events and return result of these
        run_step: analyse_input

Body:
    is thing, have mind, have mind output event handling
    event handling:
        undefined event: return unaffected
    mind_output_event_handling (class mind_events):
        move_event:
            
    run_step:
        check whether mind should die (and add destroy event if that is case)
        check whether mind should give birth (-"- make -"-)
        analyse_input: 
            now same as thing except for undefinded events
            return new event stream
        replace all things with their id in events
        let mind think about events
        replace all ids in output from mind with real things
        analyse events from mind and return analysed event stream


Mind: 
    is thing, have tasks, have current jobs, have things, knows common knowledge,\
       have memory, have goals
    find_jobs:
        prune all tasks that are not in current time range
        add tasks that are in current time range
        sort using keys: importance+original order
    think(time,input): returns intentions(=events)
        process input and do things if necessary
        try to fulfill goals:
            if function: execute that:
                if result: return that
            for all goals check if they are fulfilled:
                if not, then execute subgoals
        execute most important job:
            check needed tools:
                if I have somewhere:
                    go where it is and bring it with me
                if I don\'t have:
                    go where those generally exist and get one:
                        remeber that I don\'t need to ask twice in row
            if all tools ok:
                do most important job:
                    check if target is already done and needs only improving
    run step(time,input): returns intentions(=events):
        forget old memories
        think what to do
        remember intentions

Job:
    have main_task, have main_task_info
    can list required tools for task
    can do tasks

Memory:
    have memories
    remember:
        put behind ears
    recall:
        see if it\'s behind ear
    forget:
        remove rotten things behind ear

Task_info:
    know which tool name corresponds to what real object

Task:
    have description, have time, have place, have objects,, have importance
    do task: return event

Event:
    have command, have event_source, have description, \
         have what command is applied to, have source and target

Know:
    knows where things are usually available

Goal:
    have fulfilled, have subgoals

__str__: print verbose info
__repr__: print short info


dictlist.py:
    dictionary with list of items, key is items name

    add_value(dict, key, item):
        add value to list in dictionary using key

    remove_value(dict, item, remove_empty_key=1):
        removes value from dictionary:
            if remove_empty_key and no values:
                remove key
